//  Copyright (c) 2009 Yanagi Asakura
//
//  This software is provided 'as-is', without any express or implied
//  warranty. In no event will the authors be held liable for any damages
//  arising from the use of this software.
//
//  Permission is granted to anyone to use this software for any purpose,
//  including commercial applications, and to alter it and redistribute it
//  freely, subject to the following restrictions:
//
//  1. The origin of this software must not be misrepresented; you must not
//  claim that you wrote the original software. If you use this software
//  in a product, an acknowledgment in the product documentation would be
//  appreciated but is not required.
//
//  2. Altered source versions must be plainly marked as such, and must not be
//  misrepresented as being the original software.
//
//  3. This notice may not be removed or altered from any source
//  distribution.

//
//  ElisEffect.h
//  Elis Colors
//
//  Created by 柳 on 09/09/15.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

// ここはいろんなところから呼ばれる。呼び出しもとの差異はここで吸収。
// 微妙にすさまじい。もう弄りたくない。

// いろんなものを隠蔽した結果、ここが汚くなってしまった。
// ここが一番壮絶かも。

// アフィン変換は別クラスに分けるべきだったよね。でも直すの面倒だよね。

#import <Cocoa/Cocoa.h>
#import "ElisMedia.h"
#import "ElisKeyframe.h"

// 角度が意味不明なんだが。なんだよ3.5って。
#define ANGLE_MAX 3.5*4
#define ANGLE_MIN -3.5*4

@interface ElisEffect : NSObject {
    CIFilter* filter;
    NSString* name;
    NSMutableDictionary* params;
    NSDictionary* attrs;
    BOOL generator;
    NSMutableArray* colors, *vecs, *affine;
}

- (void)setEffectValue:(NSString*)key value:(id)v;
- (void)setInputImage:(CIImage*)cm;
- (CIImage*)getImage:(QTTime)time;
- (void)setEffectValueForTime:(NSString *)key value:(float)v time:(QTTime)time;
- (void)setEffectValue:(NSString*)key value:(id)v;
- (float)getEffectValue:(NSString*)key forTime:(QTTime)time;
- (NSMutableDictionary*)getParamDictionary;
- (float)getEffectTrueValue:(NSString*)key forTime:(QTTime)time;
- (void)setEffectTrueValueForTime:(NSString *)key value:(float)v time:(QTTime)time;


@end
