//  Copyright (c) 2009 Yanagi Asakura
//
//  This software is provided 'as-is', without any express or implied
//  warranty. In no event will the authors be held liable for any damages
//  arising from the use of this software.
//
//  Permission is granted to anyone to use this software for any purpose,
//  including commercial applications, and to alter it and redistribute it
//  freely, subject to the following restrictions:
//
//  1. The origin of this software must not be misrepresented; you must not
//  claim that you wrote the original software. If you use this software
//  in a product, an acknowledgment in the product documentation would be
//  appreciated but is not required.
//
//  2. Altered source versions must be plainly marked as such, and must not be
//  misrepresented as being the original software.
//
//  3. This notice may not be removed or altered from any source
//  distribution.

//
//  ElisPropertyTableController.h
//  Elis Colors
//
//  Created by 柳 on 09/09/15.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

// プロパティを表示する部分のコントローラー。
// GUIべったり。

// NSTableViewのデータソース。

#import <Cocoa/Cocoa.h>
#import "ElisBase.h"
#import "ElisLayer.h"
#import "ElisEffect.h"

@class ElisLayer;

@interface ElisPropertyTableController : NSObject {
    NSMutableArray* effects; // エフェクトオブジェクト本体へのポインタたち
    NSMutableArray* propertyNames; // テーブルに表示する項目の名前
    NSMutableArray* valueNames; // 項目名と対応するキー。
    
    IBOutlet id _mainController;
    IBOutlet id _propertyView;
    IBOutlet id _timeLineController;
    IBOutlet id _undoManager;
    
    ElisLayer* interestLayer;
    
    int _rowIndex;
}

- (void)createPropertyTable:(ElisLayer*)layer;
- (IBAction)sliderChanged:(id)sender;
- (float)getSelectedValueForTime:(float)time;
- (BOOL)isSelected;

- (BOOL)tableView:(NSTableView *)aTableView shouldSelectRow:(int)rowIndex;

- (BOOL)canRemoveAllKeyframe;
- (BOOL)canRemoveEffect;

@end
